#include "lib/Compatibility.frag"
#define SHADER_TYPE_TEXT

precision highp sampler2DArray;
precision highp usampler2DArray;

#define USE_MATERIAL_ID

#include "lib/Inputs.frag"
#include "lib/Packing.frag"
#include "lib/Materials.frag"
#include "lib/Slug.frag"

struct Material {
    lowp vec4 color;
    lowp vec4 effectColor;
    lowp uint font;
};

Material decodeMaterial(uint matIndex) {
    {{decoder}}
    return mat;
}

in mediump vec4 fragColor;
in vec2 fragTextureCoords;
flat in vec4 fragBanding;
flat in ivec4 fragGlyph;

uniform sampler2DArray curveTexture;
uniform usampler2DArray bandTexture;

void main() {
    Material mat = decodeMaterial(fragMaterialId);
    /* Text components without a font don't get rendered, but best to be safe */
    int layer = max(int(mat.font) - 1, 0);
    vec4 color = mix(mat.effectColor, mat.color, fragColor.a)*vec4(fragColor.rgb, 1.0);
    outColor = SlugRender(curveTexture, bandTexture, fragTextureCoords,
        color, fragBanding, fragGlyph, layer);
}
