struct FrameUniforms {
    lightCounts: vec4<u8>,
}

struct ViewUniforms {
    cameraParams: array<vec4<f32>, NUM_VIEWS>,
    viewport: array<vec4<i32>, NUM_VIEWS>,
    worldToView: array<array<vec4<f32>, 2>, NUM_VIEWS>,
    viewToWorld: array<array<vec4<f32>, 2>, NUM_VIEWS>,
    viewPositionWorld: array<vec4<f32>, NUM_VIEWS>,
    projectionMatrix: array<mat4x4<f32>, NUM_VIEWS>,
    inverseProjectionMatrix: array<mat4x4<f32>, NUM_VIEWS>,
}

#define cameraParams viewUniforms.cameraParams[drawUniforms.viewIndex]
#define viewport viewUniforms.viewport[drawUniforms.viewIndex]
#define worldToView viewUniforms.worldToView[drawUniforms.viewIndex]
#define viewToWorld viewUniforms.viewToWorld[drawUniforms.viewIndex]
#define viewPositionWorld viewUniforms.viewPositionWorld[drawUniforms.viewIndex]
#define projectionMatrix viewUniforms.projectionMatrix[drawUniforms.viewIndex]
#define inverseProjectionMatrix viewUniforms.inverseProjectionMatrix[drawUniforms.viewIndex]

struct DrawUniforms {
    viewIndex: u32,
    drawIndex: u32,
}

@group(0) @binding(0) var<uniform> frameUniforms: FrameUniforms;

@group(1) @binding(0) var<uniform> viewUniforms: ViewUniforms;

@group(2) @binding(0) var<uniform> drawUniforms: DrawUniforms;
