/**
 * Applies [fixed foveation](https://www.w3.org/TR/webxrlayers-1/#dom-xrcompositionlayer-fixedfoveation)
 * once a WebXR session is started
 *
 * Fixed foveation reduces shading cost at the periphery by rendering at lower resolutions at the
 * edges of the users vision.
 */
export class FixedFoveation extends Component {
    static Properties: {
        /** Amount to apply from 0 (none) to 1 (full) */
        fixedFoveation: {
            type: Type;
            default: number;
        };
    };
    start(): void;
    onSessionStartCallback: (() => void) | undefined;
    onActivate(): void;
    onDeactivate(): void;
    setFixedFoveation(): void;
}
import { Component } from '@wonderlandengine/api';
import { Type } from '@wonderlandengine/api';
