/**
 * (Spatial) audio listener based on [Howler.js](https://howlerjs.com/).
 *
 * Retrieves the location and orientation of the object and passes it
 * to [Howler.pos()](https://github.com/goldfire/howler.js#posx-y-z-id)
 * and [Howler.orientation()](https://github.com/goldfire/howler.js#orientationx-y-z-id).
 */
export class HowlerAudioListener extends Component {
    static Properties: {
        /** Whether audio should be spatialized/positional. */
        spatial: {
            type: Type;
            default: boolean;
        };
    };
    init(): void;
    origin: Float32Array | undefined;
    fwd: Float32Array | undefined;
    up: Float32Array | undefined;
    update(): void;
}
import { Component } from '@wonderlandengine/api';
import { Type } from '@wonderlandengine/api';
