/**
 * Downloads an image from URL and applies it as `diffuseTexture` or `flatTexture`
 * to an attached mesh component.
 *
 * Materials from the following shaders are supported:
 *  - "Phong Opaque Textured"
 *  - "Flat Opaque Textured"
 *  - "Background"
 *  - "Physical Opaque Textured"
 *  - "Foliage"
 */
export class ImageTexture extends Component {
    static Properties: {
        /** URL to download the image from */
        url: import("@wonderlandengine/api").ComponentProperty;
        /** Material to apply the video texture to */
        material: import("@wonderlandengine/api").ComponentProperty;
        /** Name of the texture property to set */
        textureProperty: import("@wonderlandengine/api").ComponentProperty;
    };
    start(): void;
}
import { Component } from '@wonderlandengine/api';
